<?

	/**
	 *  	Spirit Framework :: MyISAM Transaction Emulation
	 *	------------------------------------------------------------
	 *	Copyright : Isotope Communication 2005
	 *
	 */


	class transaction extends spa {

		var $_verbosity = 10;
		
		/**
		 * A unique identifier for the transaction?
		 *
		 * @var int
		 */
		var $_tx_id;

		/**
		 * An array of the queries carried out as part of
		 * the transaction.
		 *
		 * @var unknown_type
		 */
		var $_stored_queries = Array();

		/**
		 * Constructor, generates the transaction id and maps
		 * another mystery id?
		 *
		 * @param int $_tx_idmap
		 * @return transaction
		 */
		function transaction ( $_tx_idmap ){
			$this->_tx_id = rand();
			$this->_tx_idmap =& $_tx_idmap;
		}

		/**
		 * Returns the transaction id
		 *
		 * @return int
		 */
		function getID(){
			return ( $this->_tx_id );
		}


		/**
		 * Tries to figure out the transaction type and execute the query.
		 * Saving the results to enable rollback.
		 *
		 * @param string $query
		 * @param resource $resource
		 * @return boolean|int?
		 */
		function transact_query ( $query, $resource ){
			$this->_resource_id =& $resource;
			if ( preg_match ("/^\s*(\w+)\s/si", $query, $mx ) ){
				$this->_type = strtoupper($mx[1]);
				if ( $this->_type == 'INSERT' ){
					$this->_last_tx =& new stored_insert( $query, &$this->_resource_id, &$this->_tx_idmap );
					if ( $this->_last_tx->OK ) {
						$this->_stored_queries[] =& $this->_last_tx;
						$this->debug( "[Insert] : Stored query in transaction:{$this->_last_tx} :: " . $this->getID() );
						return ( $this->_last_tx );
					} else {
						$this->notice( "[Insert] : Transaction Creation Failed!?");
					}
				} else if ( $this->_type == 'UPDATE' ){
					$this->_last_tx =& new stored_update( $query, &$this->_resource_id, &$this->_tx_idmap );
					if ( $this->_last_tx ) {
						$this->_stored_queries[] =& $this->_last_tx;
						$this->debug( "[Update] : Stored query in transaction:{$this->_last_tx} :: " . $this->getID() );
						return ( $this->_last_tx );
					} else {
						$this->notice("[Update] Transaction Creation Failed!?");
					}
				} else if ( $this->_type == 'DELETE' ){
					$this->_last_tx =& new stored_delete( $query, &$this->_resource_id, &$this->_tx_idmap );
					if ( $this->_last_tx ) {
						$this->_stored_queries[] =& $this->_last_tx;
						$this->debug( "[Delete] : Stored query in transaction:{$this->_last_tx} :: " . $this->getID() );
						return ( $this->_last_tx );
					} else {
						$this->notice("[Delete] Transaction Creation Failed!?");
					}
				} else {
					$this->notice("Unknown transaction type : {$mx[1]}, but I'm ok with that.. ");
					return ( true );
				}
			} else {
				$this->notice("Unknown transaction type : {$mx[1]}, not keen..");
				return ( false );
			}
		}

		/**
		 * "Rollsback" the queries that have made up the transaction thus far.
		 *
		 * @return int
		 */
		function rollback( ) {
			$this->debug("Attempting to roll back transaction " . $this->getID() );
			$_rollback_success = 1;
			// Since there may be concurrent UPDATES ( which are chucked into different tables for simplicity )
			// we MUST rollback in the right direction!!.. .
			for ( $i = count($this->_stored_queries) -1; $i >= 0; $i -- ){
				//foreach ( $this->_stored_queries as $sqObj ){
				$_rollback_success &= $this->_stored_queries[$i]->rollback();
			}
			return $_rollback_success;
		}

	}






	/**
	 * "DELETE" STATEMENTS
	 *
	 * This inherits most things, just needs a parser and a rollback
	 */

	class stored_delete extends stored_query {
		
		var $zrs_acceptable = 1;
		
		/**
		 * Constructor, just calls the parents constructor
		 *
		 * @see stored_query
		 *
		 * @param string $query
		 * @param resource $resource
		 * @param unknown_type $tx_map
		 * @return stored_insert
		 */
		function stored_delete ( $query, $resource, $tx_map ){
			$this->stored_query( $query, $resource, $tx_map );
		}

		/**
		 * Parses the query string to confirm it's an delete statement
		 *
		 * @return  string|void
		 */
		function parse( ){
			if ( preg_match ("/^\s*DELETE\s+FROM\s+([\w\.]+)\s+WHERE\s+(.*)$/si", $this->_query, $mx ) ) {
				$tbd = split("\.",trim($mx[1]));
				if (count($tbd)==1){
					$this->_database 	= mysql_result(mysql_query("SELECT DATABASE()"),0);
					$this->_table		= $tbd[0];
				} else {
					$this->_database 	= $tbd[0];
					$this->_table		= $tbd[1];
				}
				$this->_where_statements = $mx[2];
				/**
				 * OK. At this stage, create a temporary table and store the data in there..
				 * ... incase we want to roll back...
				 */
				// Define the Table ID.
				$this->tmp_table_ID = 'txTMP_'.$this->_database.'_'.$this->_table.'_'.rand();
				// Create a unique temporary table..
				$this->_execute( "CREATE TEMPORARY TABLE IF NOT EXISTS $this->tmp_table_ID LIKE $this->_database.$this->_table" );
				// Move the records we're changing in a sec into the temporary table..
				$this->_execute( "INSERT INTO $this->tmp_table_ID SELECT * FROM $this->_database.$this->_table WHERE $this->_where_statements " );
				// Ok... good to groove
				return ( $this->_database && $this->_table );
			} else {
				$this->notice("[Delete] : This is not an (acceptable) delete query!? : [$this->_query]");
			}
		}


		/**
		 * Rollsback the transaction by inserting over the top of the updated
		 * record from the temporary table.  ( Lifted from the UPDATE class, but
		 * we've changed the DUPLICATE KEY UPDATE to just use $this->_id_column
		 *
		 * @return boolean
		 */
		function rollback(){
			if ( $this->_database && $this->_table ){
				
				// Should be a simple rollback.. insert ( UPDATE ) over the top from our temporary table..
				$this->_rollback_query = " INSERT INTO $this->_database.$this->_table SELECT * FROM $this->tmp_table_ID WHERE $this->_where_statements "
									   . " ON DUPLICATE KEY UPDATE $this->_database.$this->_table.{$this->_id_column} = $this->_database.$this->_table.{$this->_id_column}";
				//error_log("ROLLBACK Q: $this->_rollback_query");
				return ( $this->execute_rollback() );
				
			} else {
				$this->notice("[Delete] :: Rollback Failed! : ($this->_database && $this->_table)");
				return ( false );
			}
		}

	}
	
	
	/**
	 * "INSERT" STATEMENTS
	 *
	 * This inherits most things, just needs a parser and a rollback
	 */

	class stored_insert extends stored_query {

		/**
		 * Constructor, just calls the parents constructor
		 *
		 * @see stored_query
		 *
		 * @param string $query
		 * @param resource $resource
		 * @param unknown_type $tx_map
		 * @return stored_insert
		 */
		function stored_insert ( $query, $resource, $tx_map ){
			$this->stored_query( $query, $resource, $tx_map );
		}

		/**
		 * Parses the query string to confirm it's an insert statement
		 *
		 * @return  string|void
		 */
		function parse( ){
			if ( preg_match ("/^\s*INSERT\s+INTO\s+(.*?)\s+[\(V]/si", $this->_query, $mx ) ) {
				$tbd = split("\.",trim($mx[1]));
				if (count($tbd)==1){
					$this->_database 	= mysql_result(mysql_query("SELECT DATABASE()"),0);
					$this->_table		= $tbd[0];
				} else {
					$this->_database 	= $tbd[0];
					$this->_table		= $tbd[1];
				}
				if ( preg_match ( "/ SELECT /", $this->_query ) ) {
					//error_log("Identified 'INSERT <- SELECT'; allowing zero record set");
					$this->zrs_acceptable = 1; // Accept ZeroRecords updated...
				}
				return ( $this->_database && $this->_table );
			} else {
				$this->notice("[Insert] : This is not an insert query!? : [$this->_query]");
			}
		}


		/**
		 * Rollsback the insert by carrying out a delete.
		 *
		 * @return boolean
		 */
		function rollback(){
			if ( ( ( $this->_insert_id && $this->_count ) || ( $this->zrs_acceptable ) ) && $this->_database && $this->_table ){
				if ( $this->_count == 1 ){
					$where = " $this->_id_column = $this->_insert_id";
				} else {
					$where = " $this->_id_column < ".($this->_insert_id+$this->_count)." AND $this->_id_column >= $this->_insert_id ";
				}
				$this->_rollback_query = "DELETE FROM $this->_database.$this->_table WHERE $where LIMIT $this->_count";
				//error_log("ROLLBACK Q: $this->_rollback_query");
				return ( $this->execute_rollback() );
			} else {
				$this->notice("[Insert] : Rollback Failed! : $this->_insert_id && $this->_count && $this->_database && $this->_table");
				return ( false );
			}
		}

	}

	/**
	 * "UPDATE" STATEMENTS
	 *
	 * This inherits most things, just needs a parser and a rollback
	 */

	class stored_update extends stored_query {

		/**
		 * Flag which defines whether not having any records updated
		 * after query execution is acceptable.
		 *
		 * @var int
		 */
		var $zrs_acceptable = 1; 			// Accept ZeroRecords updated...
		var $_noIdColumnRequirement = 1; 	// We don't need to know the IDs of the columns we're dealing with.

		/**
		 * Constructor which just calls the parents constructor
		 *
		 * @see stored_query
		 *
		 * @param string $query
		 * @param resource $resource
		 * @param unknown_type $tx_map
		 * @return stored_update
		 */
		function stored_update ( $query, $resource, $tx_map ){
			$this->stored_query( $query, $resource, $tx_map );
		}

		/**
		 * Checks that the query string is an update statement, creates
		 * a temporary table ot handle the transaction side of things
		 * and then executes the query.
		 *
		 * @return  string|void
		 */
		function parse( ){
			/**
			 * 	Remove spurious commas, for a bit.. so our split works..
			 * 	(Someone help! ;-)... need some proper tokenisation but.. )
			 * 
			 * 	Incidentally - these aren't (currently) ever put back in.. since we don't really care about the RHS's of the SETs..
			 */
			$sQuery = $this->_query;
			while ( preg_match ( "/(\(.+\,.+\))/", $sQuery, $mx ) && ( $paranoia < 5 ) ){
				$chunk 	= $mx[1];
				$sanitised 	= preg_replace('/,/','~COMMA~',$chunk);
				$safe_reg 	= addcslashes($mx[1],'(){}[]/\#`^$.+*?');
				$this->debug("[$paranoia] : $safe_reg");
				$sQuery = preg_replace("/$safe_reg/",$sanitised,$sQuery);
				$paranoia ++;
			}
			if ( preg_match ("/^\s*UPDATE\s*(.*?)\s*SET\s*(.*?)\s*((WHERE|LIMIT|ORDER|$).*)/si", $sQuery, $mx ) ) {
				/**
				 * 	Lets assume it's a compound update..
				 */
				$aTables			= split('\,',trim($mx[1]));
				$this->_sFullTables 	= $mx[1];
				
				/**
				 * 	The WHERE statements are constant throughout.. since they have a bearing on row selection
				 * 	we must ensure that we do what's neccasary for them to be usable on all our SELECTs.. 
				 */
				$this->_wlo_statements 	= $mx[3];
				
				/**
				 * 	Now through each table..  replacing the string with a db/table kv pairs.. 
				 */
				foreach ( $aTables as $iKey => $sTable ){
					$tbd = split("\.",trim($sTable));
					$aTables[$iKey] = array();
					if (count($tbd)==1){
						$aTables[$iKey]['database']	= mysql_result(mysql_query("SELECT DATABASE()"),0);
						$aTables[$iKey]['table']		= $tbd[0];
					} else {
						$aTables[$iKey]['database']	= $tbd[0];
						$aTables[$iKey]['table']		= $tbd[1];
					}
					
					/**
					 * 	For now lets get descriptions for each table we MAY need.  
					 * 	This could easily be over kill, so could be optimised a bit
					 */
					$aTables[$iKey]['possible_columns'] = $this->_describe( $aTables[$iKey]['database'], $aTables[$iKey]['table'] );
				}
				/**
				 * 	Ok, the SET statement needs to be divvied up between each table..
				 * 	Sure this could be written more efficiently... but.. cinema in 20 mins and I need to get popcorn first!!
				 */
				$setList = split(",",trim($mx[2]));
				foreach ( $setList as $setItem ){
					$bMatched = false;
					preg_match("/(\w+)\s*=/",$setItem,$mx);
					$setColumn = $mx[1];
					/**
					 * 	Will only work with single column names "foo_id", not table.column or database.table.column or alias.column (YET!)
					 */
					foreach ( $aTables as $iKey => $sTable ){
						if ( $sTable['possible_columns'][$setColumn] ){
							$aTables[$iKey]['columns'][] = $setColumn;
							$bMatched = true;
							$this->debug("[Update] : Matching column '$setColumn' to '{$sTable['database']}.{$sTable['table']}'");
							next;
						} 
					}
					if ( !$bMatched ){
						$this->notice("[Update] : Column matching failed ($setColumn).  Thing this queries a bit too complex for me!");
						return false;
					}
				}
				
				/**
				 * 	Woohoo.. ok, let's now do our transaction queries... throw the bits we need for each restoration into its own tmp.
				 */
				$this->debug("[Update] : Processing transation storage... ");
				$bOk = 1;
				foreach ( $aTables as $iKey => $sTable ){
					if ( count( $sTable['columns'] ) ) {
						$this->debug("[Update] : Storing transaction data for '{$aTables[$iKey]['database']}.{$aTables[$iKey]['table']}'; " . count( $aTables[$iKey]['columns'] ) . " column of relevance.. " );
						
						// Define the Table ID.
						$aTables[$iKey]['tmp_table_ID'] = 'txTMP_'.$aTables[$iKey]['database'].'_'.$aTables[$iKey]['table'].'_'.rand();
						// Create a unique temporary table..
						$bOk &= $this->_execute( "CREATE TEMPORARY TABLE IF NOT EXISTS {$aTables[$iKey]['tmp_table_ID']} LIKE {$aTables[$iKey]['database']}.{$aTables[$iKey]['table']}" );
						// Move the records we're changing in a sec into the temporary table.. ( ONLY the columns from this table though... )
						$bOk &= $this->_execute( "INSERT INTO {$aTables[$iKey]['tmp_table_ID']} SELECT {$aTables[$iKey]['database']}.{$aTables[$iKey]['table']}.* FROM $this->_sFullTables $this->_wlo_statements " );
						
						$this->debug( "INSERT INTO {$aTables[$iKey]['tmp_table_ID']} SELECT {$aTables[$iKey]['database']}.{$aTables[$iKey]['table']}.* FROM $this->_sFullTables $this->_wlo_statements " );
						
					} else {
						$this->debug("[Update] : Ignoring '{$sTable['database']}.{$sTable['table']}', asuming it's just in the query for support!");
					}
				}
				
				// ~~ a little debuggy nonsense :-)
				if ( $bOk ){
					if ( count( $aTables) > 1 ){
						$this->debug("[Update] : Compund Update appears to be going well... ");
					} else {
						$this->debug("[Update] : Basic Update appears to be going well... ");
					}
				}
				
				$this->_aTables = $aTables;
				return $bOk;
				
			} else {
				$this->notice("[Update] : This is not an update query!? : [$this->_query]");
			}
		}


		/**
		 * Rolls back the transaction by inserting over the top of the updated
		 * record from the temporary table.
		 *
		 * @return boolean
		 */
		function rollback(){
			if ( is_array( $this->_aTables) ){
				$sDebug = (count($this->_aTables)>1) ? ' compound update of ' . count($this->_aTables) . ' tables.' : ' simple, single table update.';
				$this->debug("[Update] : Rolling back $sDebug ");
				
				/**
				 * 	Cycle through our table stack backwards and re-assert the data to the database.
				 * 	The author doesn't know whether going backwards is strictly neccasary.. but he feels it'd be wise.
				 */
				$bOk = true;
				
				foreach ( array_reverse( $this->_aTables ) as $iKey => $sTable ){
					$_updates = array();
					/**
					 * 	Only dealing with this tables columns... 
					 */
					foreach ( $sTable['columns'] as $col ){
						$_updates[] = "{$sTable['database']}.{$sTable['table']}.$col = {$sTable['tmp_table_ID']}.$col";
					}
					
					/**
					 * 	Should be a simple rollback.. insert ( UPDATE ) over the top from our temporary table..
					 * 	NB; 	Now we're dealing with compound queries we've actually dropped the WHERE clause.
					 * 		The theory goes that all the TEMP data is relevant..
					 */
					$this->_rollback_query = " INSERT INTO {$sTable['database']}.{$sTable['table']} SELECT * FROM {$sTable['tmp_table_ID']} " // WHERE $this->_where_statements 
										   . " ON DUPLICATE KEY UPDATE " . join (",",$_updates) ;
					$this->debug("[Update] : ROLLBACK Q: $this->_rollback_query");
					$bOk &= $this->execute_rollback();	
				}
				
				return $bOk;
				
			} else {
				$this->notice("[Update] : Rollback Failed! : $this->_database && $this->_table");
				return ( false );
			}
		}

	}



	/**
	* RESERVED for future use.
	*	Each query has it's own object to store the query... but they should
	*	extend this so we can tart up the error reporting in one go..
	*/
	class stored_query extends spa {

		var $_verbosity = 10;
		
		/**
		 * Constructor, immediately tries to execute a query
		 *
		 * @param string $query
		 * @param resource $resource
		 * @param unknown_type $_tx_idmap
		 * @return stored_query
		 */
		function stored_query( $query, $resource, $_tx_idmap ){
			$this->_resource_id 	=& $resource;
			$this->_tx_idmap		=& $_tx_idmap;
			$this->_query 			= 	$query;
			$this->OK				= 	0;
			if ( $this->parse() ){
				if ( $this->_noIdColumnRequirement || ( $this->_id_column = $this->getIDColumn( $this->_database, $this->_table ) ) ) {
					if ( $this->execute() ) {
						if ( $this->store() ){
							//error_log("[DB:TX] All good!");
							$this->OK = 1;
							return ( $this->_count );
						} else {
							$this->notice("[DB:TX] : Store Failed : " . $this->_query );
						}
					} else {
						$this->notice("[DB:TX] : Execute Failed");
					}
				} else {
					$this->notice("[DB:TX] : No Primary Column Defined.");
				}
			} else {
				$this->notice("[DB:TX] : Parse Failed");
			}
		}

		/**
		 * Used to parse queries, should be overlodaed.
		 *
		 * @return boolean
		 */
		function parse(){
			$this->notice("[DB:TX] : NO DEFAULT QUERY PARSER! PLEASE OVERLOAD!");
			return ( false );
		}

		/**
		 * Public wrapper for _execute
		 *
		 * @see _execute
		 *
		 * @return boolean
		 */
		function execute(){
			return ( $this->_execute( $this->_query, $this->_resource_id ) );
		}

		/**
		 * Executes a rollback query
		 *
		 * @return boolean
		 */
		function execute_rollback(){
			return ( $this->_execute( $this->_rollback_query, $this->_resource_id ) );
		}

		/**
		 * Executes a query
		 *
		 * @param string $query
		 * @return boolean
		 */
		function _execute($query){
			if ( mysql_query( $query, $this->_resource_id ) ){
				return true;
			} else {
				$this->notice("[DB:TX] : " . mysql_error() . " :: QUERY [$query]");
				return false;
			}
		}
		
		function _describe( $sDatabase, $sTable ){
			$sQuery = "SHOW COLUMNS FROM $sDatabase.$sTable";
			if ( $_result = mysql_query( $sQuery, $this->_resource_id ) ) {
				while ( $row = mysql_fetch_array( $_result, MYSQL_ASSOC ) ){ 
					$_rtn[$row['Field']] = true;
				}
				mysql_free_result( $_result );
				return $_rtn;
			} else {
				$this->notice("[Describe] :: Failed: $sQuery " . mysql_error());
				return false; // Doh!
			}
		}

		/**
		 * Stores some meta data on the last transaction
		 *
		 * @return int|unknown
		 */
		function store(){
			// NB! Insert ID is the FIRST insert ID of multiple inserts..
			$this->_insert_id 		= mysql_insert_id ( $this->_resource_id );
			$this->_count 		= mysql_affected_rows ( $this->_resource_id );
			$this->debug("STORING TRANSACTION: $this->_count rows up to row $this->_insert_id");
			return ( $this->_insert_id || $this->_count || $this->zrs_acceptable );
		}

		/**
		  * Finds which column in the database the ID refers to...
		  *
		  * In theory this doesn't need to be done until a rollback is required.
		  * Now, for now we've cached this all the way up in the Spirit core_library object
		  * ( partly cos it's probably useful elsewhere.. but
		  * I would think that we could leave the "Fetch" of this data until it's required so it's
		  * only ever pulled out of this function just before it's needed... incase we want to change
		  * the way its obtained..
		  *
		  * @param string $db
		  * @param string  $tbl
		  */
		function getIDColumn( $db, $tbl ){
			if ( $col = $this->_tx_idmap["$db.$tbl"] ){
				return $col['col'];
			} else {
				/**
				 * 	Patch for circumstances where this isn't cached by Spirit and provided.. 
				 * 	.. potentially a little repetative! :-o
				 */
				$sQuery = "SHOW COLUMNS FROM $db.$tbl";
				if ( $_result = mysql_query( $sQuery, $this->_resource_id ) ) {
					while ( $row = mysql_fetch_array( $_result, MYSQL_ASSOC ) ){ 
						if ( strpos( $row['Key'], 'PRI' ) !== FALSE ){
							mysql_free_result( $_result );
							return $row['Field'];
						}
					}
				}
				$this->notice("[DB:TX] : Could not define ID Column ($db.$tbl)");
			}
		}
	}
	
	
	/**
	 * 	This is a little public announcer class.  Replace it with whatever's appropriate for you.. 
	 * 	
	 * 	( sorry it's a bit slack - it replaces a real class that's not releasable at the moment. )
	 *
	 */
	class spa {
		
		/**
		 * Change this to lower the output of the transaction system!
		 *
		 * @var integer
		 */
		var $_verbosity = 4;
		
		var $_token = "transactions";
		
		function error( $sMsg ){
			if ( $this -> _verbosity > 0 ){
				error_log("[$this->_token:error] :: $sMsg");
			}
		}
		
		function warn( $sMsg ){
			if ( $this -> _verbosity > 1 ){
				error_log("[$this->_token:warning] :: $sMsg");
			}
		}
		
		function notice( $sMsg ){
			if ( $this -> _verbosity > 2 ){
				error_log("[$this->_token:notice] :: $sMsg");
			}
		}
		
		function debug( $sMsg ){
			if ( $this -> _verbosity > 3 ){
				error_log("[$this->_token:debug] :: $sMsg");
			}
		}
		
	}
	
?>